﻿
function cs_PBA_Launcher (thisObj) {
    
    scriptVersion = "1.0";

g_Max_folder_depth = 3;

function isAfterEffects()
{
    return BridgeTalk.appName == "aftereffects";
}

function isCreativeClouds()
{
    //majar version AE
    // 11 : CS6
    // 12 : CC
    return app.version.split(".")[0] >= 12;
}

function apply_PBA_to_selected_layer(pb_filepath)
{
    if(isAfterEffects())
    {
        var activeComp = app.project.activeItem;
        if(activeComp == null)
        {
            alert("Select a layer","PBA Launcher");
            return ;
        }
        var selectedLayers = activeComp.selectedLayers;
        if(selectedLayers.length <= 0)
        {
            alert("Select a layer","PBA Launcher");
            return ;
        }
        else
        {
            app.beginUndoGroup("PBA Launcher");
            var curLayer = selectedLayers[0];
            var markers = curLayer.property("Marker");        
            ///////////////////////////////////////////////////////////////////////////////
            //Apply PBAccelerator with filepath

            // 1. Make marker has filepath as comment.
            var marker = new MarkerValue(pb_filepath);

            // 2. Set this marker to target layer.
            var add_time = 0;
            if(markers.numKeys>0)
            {
                // If there are markers, set this new marker as first marker.
                add_time = markers.keyTime(1) - 1.;
            }
            markers.setValueAtTime(add_time,marker);

            // 3. Apply PBAccelerator
            //   PBAccelerator loads pbk or pbg when the first marker 
            //   has filepath of pbk or pbg as comment
            if(curLayer('Effects').canAddProperty('PBAccelerator'))
            {
                curLayer('Effects').addProperty('PBAccelerator');
            }
            else
            {
                alert("PBAccelerator is not installed.\nInstall and restart AE.","PBA_Launcher",true);
            }

            // 4. Remove the marker
            markers.removeKey(1);
            ///////////////////////////////////////////////////////////////////////////////
            app.endUndoGroup();
        }
    }
    else
    {
        var pb = File(pb_filepath);
        if(pb.exists && pb instanceof File)
        {
            pb.execute();
        }
    }
}

function isSecurityPrefSet()
{
    var securitySetting = 0;
    if(isAfterEffects ())
    {
        var securitySetting = app.preferences.getPrefAsLong("Main Pref Section",
                        "Pref_SCRIPTING_FILE_NETWORK_SECURITY");
    }
    return (securitySetting == 1);
}

function createResourceFile (filename, resourceFolder) 
{    
    var binaryStrings =
    {
        "Folder_16x16.png": "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x10\b\x06\x00\x00\x00\x1F\u00F3\u00FFa\x00\x00\x00\tpHYs\x00\x00\x0B\x13\x00\x00\x0B\x13\x01\x00\u009A\u009C\x18\x00\x00\nMiCCPPhotoshop ICC profile\x00\x00x\u00DA\u009DSwX\u0093\u00F7\x16>\u00DF\u00F7e\x0FVB\u00D8\u00F0\u00B1\u0097l\u0081\x00\"#\u00AC\b\u00C8\x10Y\u00A2\x10\u0092\x00a\u0084\x10\x12@\u00C5\u0085\u0088\nV\x14\x15\x11\u009CHU\u00C4\u0082\u00D5\nH\u009D\u0088\u00E2\u00A0(\u00B8gA\u008A\u0088Z\u008BU\\8\u00EE\x1F\u00DC\u00A7\u00B5}z\u00EF\u00ED\u00ED\u00FB\u00D7\u00FB\u00BC\u00E7\u009C\u00E7\u00FC\u00CEy\u00CF\x0F\u0080\x11\x12&\u0091\u00E6\u00A2j\x009R\u0085<:\u00D8\x1F\u008FOH\u00C4\u00C9\u00BD\u0080\x02\x15H\u00E0\x04 \x10\u00E6\u00CB\u00C2g\x05\u00C5\x00\x00\u00F0\x03yx~t\u00B0?\u00FC\x01\u00AFo\x00\x02\x00p\u00D5.$\x12\u00C7\u00E1\u00FF\u0083\u00BAP&W\x00 \u0091\x00\u00E0\"\x12\u00E7\x0B\x01\u0090R\x00\u00C8.T\u00C8\x14\x00\u00C8\x18\x00\u00B0S\u00B3d\n\x00\u0094\x00\x00ly|B\"\x00\u00AA\r\x00\u00EC\u00F4I>\x05\x00\u00D8\u00A9\u0093\u00DC\x17\x00\u00D8\u00A2\x1C\u00A9\b\x00\u008D\x01\x00\u0099(G$\x02@\u00BB\x00`U\u0081R,\x02\u00C0\u00C2\x00\u00A0\u00AC@\".\x04\u00C0\u00AE\x01\u0080Y\u00B62G\x02\u0080\u00BD\x05\x00v\u008EX\u0090\x0F@`\x00\u0080\u0099B,\u00CC\x00 8\x02\x00C\x1E\x13\u00CD\x03 L\x03\u00A00\u00D2\u00BF\u00E0\u00A9_p\u0085\u00B8H\x01\x00\u00C0\u00CB\u0095\u00CD\u0097K\u00D23\x14\u00B8\u0095\u00D0\x1Aw\u00F2\u00F0\u00E0\u00E2!\u00E2\u00C2l\u00B1Ba\x17)\x10f\t\u00E4\"\u009C\u0097\u009B#\x13H\u00E7\x03L\u00CE\f\x00\x00\x1A\u00F9\u00D1\u00C1\u00FE8?\u0090\u00E7\u00E6\u00E4\u00E1\u00E6f\u00E7l\u00EF\u00F4\u00C5\u00A2\u00FEk\u00F0o\">!\u00F1\u00DF\u00FE\u00BC\u008C\x02\x04\x00\x10N\u00CF\u00EF\u00DA_\u00E5\u00E5\u00D6\x03p\u00C7\x01\u00B0u\u00BFk\u00A9[\x00\u00DAV\x00h\u00DF\u00F9]3\u00DB\t\u00A0Z\n\u00D0z\u00F9\u008By8\u00FC@\x1E\u009E\u00A1P\u00C8<\x1D\x1C\n\x0B\x0B\u00ED%b\u00A1\u00BD0\u00E3\u008B>\u00FF3\u00E1o\u00E0\u008B~\u00F6\u00FC@\x1E\u00FE\u00DBz\u00F0\x00q\u009A@\u0099\u00AD\u00C0\u00A3\u0083\u00FDqanv\u00AER\u008E\u00E7\u00CB\x04B1n\u00F7\u00E7#\u00FE\u00C7\u0085\x7F\u00FD\u008E)\u00D1\u00E24\u00B1\\,\x15\u008A\u00F1X\u0089\u00B8P\"M\u00C7y\u00B9R\u0091D!\u00C9\u0095\u00E2\x12\u00E9\x7F2\u00F1\x1F\u0096\u00FD\t\u0093w\r\x00\u00AC\u0086O\u00C0N\u00B6\x07\u00B5\u00CBl\u00C0~\u00EE\x01\x02\u008B\x0EX\u00D2v\x00@~\u00F3-\u008C\x1A\x0B\u0091\x00\x10g42y\u00F7\x00\x00\u0093\u00BF\u00F9\u008F@+\x01\x00\u00CD\u0097\u00A4\u00E3\x00\x00\u00BC\u00E8\x18\\\u00A8\u0094\x17L\u00C6\b\x00\x00D\u00A0\u0081*\u00B0A\x07\f\u00C1\x14\u00AC\u00C0\x0E\u009C\u00C1\x1D\u00BC\u00C0\x17\x02a\x06D@\f$\u00C0<\x10B\x06\u00E4\u0080\x1C\n\u00A1\x18\u0096A\x19T\u00C0:\u00D8\x04\u00B5\u00B0\x03\x1A\u00A0\x11\u009A\u00E1\x10\u00B4\u00C118\r\u00E7\u00E0\x12\\\u0081\u00EBp\x17\x06`\x18\u009E\u00C2\x18\u00BC\u0086\t\x04A\u00C8\b\x13a!:\u0088\x11b\u008E\u00D8\"\u00CE\b\x17\u0099\u008E\x04\"aH4\u0092\u0080\u00A4 \u00E9\u0088\x14Q\"\u00C5\u00C8r\u00A4\x02\u00A9Bj\u0091]H#\u00F2-r\x149\u008D\\@\u00FA\u0090\u00DB\u00C8 2\u008A\u00FC\u008A\u00BCG1\u0094\u0081\u00B2Q\x03\u00D4\x02u@\u00B9\u00A8\x1F\x1A\u008A\u00C6\u00A0s\u00D1t4\x0F]\u0080\u0096\u00A2k\u00D1\x1A\u00B4\x1E=\u0080\u00B6\u00A2\u00A7\u00D1K\u00E8ut\x00}\u008A\u008Ec\u0080\u00D11\x0Ef\u008C\u00D9a\\\u008C\u0087E`\u0089X\x1A&\u00C7\x16c\u00E5X5V\u008F5c\x1DX7v\x15\x1B\u00C0\u009Ea\u00EF\b$\x02\u008B\u0080\x13\u00EC\b^\u0084\x10\u00C2l\u0082\u0090\u0090GXLXC\u00A8%\u00EC#\u00B4\x12\u00BA\bW\t\u0083\u00841\u00C2'\"\u0093\u00A8O\u00B4%z\x12\u00F9\u00C4xb:\u00B1\u0090XF\u00AC&\u00EE!\x1E!\u009E%^'\x0E\x13_\u0093H$\x0E\u00C9\u0092\u00E4N\n!%\u00902I\x0BIkH\u00DBH-\u00A4S\u00A4>\u00D2\x10i\u009CL&\u00EB\u0090m\u00C9\u00DE\u00E4\b\u00B2\u0080\u00AC \u0097\u0091\u00B7\u0090\x0F\u0090O\u0092\u00FB\u00C9\u00C3\u00E4\u00B7\x14:\u00C5\u0088\u00E2L\t\u00A2$R\u00A4\u0094\x12J5e?\u00E5\x04\u00A5\u009F2B\u0099\u00A0\u00AAQ\u00CD\u00A9\u009E\u00D4\b\u00AA\u0088:\u009FZIm\u00A0vP/S\u0087\u00A9\x134u\u009A%\u00CD\u009B\x16C\u00CB\u00A4-\u00A3\u00D5\u00D0\u009Aigi\u00F7h/\u00E9t\u00BA\t\u00DD\u0083\x1EE\u0097\u00D0\u0097\u00D2k\u00E8\x07\u00E9\u00E7\u00E9\u0083\u00F4w\f\r\u0086\r\u0083\u00C7Hb(\x19k\x19{\x19\u00A7\x18\u00B7\x19/\u0099L\u00A6\x05\u00D3\u0097\u0099\u00C8T0\u00D72\x1B\u0099g\u0098\x0F\u0098oUX*\u00F6*|\x15\u0091\u00CA\x12\u0095:\u0095V\u0095~\u0095\u00E7\u00AATUsU?\u00D5y\u00AA\x0BT\u00ABU\x0F\u00AB^V}\u00A6FU\u00B3P\u00E3\u00A9\t\u00D4\x16\u00AB\u00D5\u00A9\x1DU\u00BB\u00A96\u00AE\u00CERwR\u008FP\u00CFQ_\u00A3\u00BE_\u00FD\u0082\u00FAc\r\u00B2\u0086\u0085F\u00A0\u0086H\u00A3Tc\u00B7\u00C6\x19\u008D!\x16\u00C62e\u00F1XB\u00D6rV\x03\u00EB,k\u0098Mb[\u00B2\u00F9\u00ECLv\x05\u00FB\x1Bv/{LSCs\u00AAf\u00ACf\u0091f\u009D\u00E6q\u00CD\x01\x0E\u00C6\u00B1\u00E0\u00F09\u00D9\u009CJ\u00CE!\u00CE\r\u00CE{-\x03-?-\u00B1\u00D6j\u00ADf\u00AD~\u00AD7\u00DAz\u00DA\u00BE\u00DAb\u00EDr\u00ED\x16\u00ED\u00EB\u00DA\u00EFup\u009D@\u009D,\u009D\u00F5:m:\u00F7u\t\u00BA6\u00BAQ\u00BA\u0085\u00BA\u00DBu\u00CF\u00EA>\u00D3c\u00EBy\u00E9\t\u00F5\u00CA\u00F5\x0E\u00E9\u00DD\u00D1G\u00F5m\u00F4\u00A3\u00F5\x17\u00EA\u00EF\u00D6\u00EF\u00D1\x1F704\b6\u0090\x19l18c\u00F0\u00CC\u0090c\u00E8k\u0098i\u00B8\u00D1\u00F0\u0084\u00E1\u00A8\x11\u00CBh\u00BA\u0091\u00C4h\u00A3\u00D1I\u00A3'\u00B8&\u00EE\u0087g\u00E35x\x17>f\u00ACo\x1Cb\u00AC4\u00DEe\u00DCk<abi2\u00DB\u00A4\u00C4\u00A4\u00C5\u00E4\u00BE)\u00CD\u0094k\u009Af\u00BA\u00D1\u00B4\u00D3t\u00CC\u00CC\u00C8,\u00DC\u00AC\u00D8\u00AC\u00C9\u00EC\u008E9\u00D5\u009Ck\u009Ea\u00BE\u00D9\u00BC\u00DB\u00FC\u008D\u0085\u00A5E\u009C\u00C5J\u008B6\u008B\u00C7\u0096\u00DA\u0096|\u00CB\x05\u0096M\u0096\u00F7\u00AC\u0098V>VyV\u00F5V\u00D7\u00ACI\u00D6\\\u00EB,\u00EBm\u00D6WlP\x1BW\u009B\f\u009B:\u009B\u00CB\u00B6\u00A8\u00AD\u009B\u00AD\u00C4v\u009Bm\u00DF\x14\u00E2\x14\u008F)\u00D2)\u00F5Sn\u00DA1\u00EC\u00FC\u00EC\n\u00EC\u009A\u00EC\x06\u00ED9\u00F6a\u00F6%\u00F6m\u00F6\u00CF\x1D\u00CC\x1C\x12\x1D\u00D6;t;|rtu\u00CCvlp\u00BC\u00EB\u00A4\u00E14\u00C3\u00A9\u00C4\u00A9\u00C3\u00E9Wg\x1Bg\u00A1s\u009D\u00F35\x17\u00A6K\u0090\u00CB\x12\u0097v\u0097\x17Sm\u00A7\u008A\u00A7n\u009Fz\u00CB\u0095\u00E5\x1A\u00EE\u00BA\u00D2\u00B5\u00D3\u00F5\u00A3\u009B\u00BB\u009B\u00DC\u00AD\u00D9m\u00D4\u00DD\u00CC=\u00C5}\u00AB\u00FBM.\u009B\x1B\u00C9]\u00C3=\u00EFA\u00F4\u00F0\u00F7X\u00E2q\u00CC\u00E3\u009D\u00A7\u009B\u00A7\u00C2\u00F3\u0090\u00E7/^v^Y^\u00FB\u00BD\x1EO\u00B3\u009C&\u009E\u00D60m\u00C8\u00DB\u00C4[\u00E0\u00BD\u00CB{`:>=e\u00FA\u00CE\u00E9\x03>\u00C6>\x02\u009Fz\u009F\u0087\u00BE\u00A6\u00BE\"\u00DF=\u00BE#~\u00D6~\u0099~\x07\u00FC\u009E\u00FB;\u00FA\u00CB\u00FD\u008F\u00F8\u00BF\u00E1y\u00F2\x16\u00F1N\x05`\x01\u00C1\x01\u00E5\x01\u00BD\u0081\x1A\u0081\u00B3\x03k\x03\x1F\x04\u0099\x04\u00A5\x075\x05\u008D\x05\u00BB\x06/\f>\x15B\f\t\rY\x1Fr\u0093o\u00C0\x17\u00F2\x1B\u00F9c3\u00DCg,\u009A\u00D1\x15\u00CA\b\u009D\x15Z\x1B\u00FA0\u00CC&L\x1E\u00D6\x11\u008E\u0086\u00CF\b\u00DF\x10~o\u00A6\u00F9L\u00E9\u00CC\u00B6\b\u0088\u00E0Gl\u0088\u00B8\x1Fi\x19\u0099\x17\u00F9}\x14)*2\u00AA.\u00EAQ\u00B4Stqt\u00F7,\u00D6\u00AC\u00E4Y\u00FBg\u00BD\u008E\u00F1\u008F\u00A9\u008C\u00B9;\u00DBj\u00B6rvg\u00ACjlRlc\u00EC\u009B\u00B8\u0080\u00B8\u00AA\u00B8\u0081x\u0087\u00F8E\u00F1\u0097\x12t\x13$\t\u00ED\u0089\u00E4\u00C4\u00D8\u00C4=\u0089\u00E3s\x02\u00E7l\u009A3\u009C\u00E4\u009AT\u0096tc\u00AE\u00E5\u00DC\u00A2\u00B9\x17\u00E6\u00E9\u00CE\u00CB\u009Ew<Y5Y\u0090|8\u0085\u0098\x12\u0097\u00B2?\u00E5\u0083 BP/\x18O\u00E5\u00A7nM\x1D\x13\u00F2\u0084\u009B\u0085OE\u00BE\u00A2\u008D\u00A2Q\u00B1\u00B7\u00B8J<\u0092\u00E6\u009DV\u0095\u00F68\u00DD;}C\u00FAh\u0086OFu\u00C63\tOR+y\u0091\x19\u0092\u00B9#\u00F3MVD\u00D6\u00DE\u00AC\u00CF\u00D9q\u00D9-9\u0094\u009C\u0094\u009C\u00A3R\ri\u0096\u00B4+\u00D70\u00B7(\u00B7Of++\u0093\r\u00E4y\u00E6m\u00CA\x1B\u0093\u0087\u00CA\u00F7\u00E4#\u00F9s\u00F3\u00DB\x15l\u0085L\u00D1\u00A3\u00B4R\u00AEP\x0E\x16L/\u00A8+x[\x18[x\u00B8H\u00BDHZ\u00D43\u00DFf\u00FE\u00EA\u00F9#\x0B\u0082\x16|\u00BD\u0090\u00B0P\u00B8\u00B0\u00B3\u00D8\u00B8xY\u00F1\u00E0\"\u00BFE\u00BB\x16#\u008BS\x17w.1]R\u00BAdxi\u00F0\u00D2}\u00CBh\u00CB\u00B2\u0096\u00FDP\u00E2XRU\u00F2jy\u00DC\u00F2\u008ER\u0083\u00D2\u00A5\u00A5C+\u0082W4\u0095\u00A9\u0094\u00C9\u00CBn\u00AE\u00F4Z\u00B9c\x15a\u0095dU\u00EFj\u0097\u00D5[V\x7F*\x17\u0095_\u00ACp\u00AC\u00A8\u00AE\u00F8\u00B0F\u00B8\u00E6\u00E2WN_\u00D5|\u00F5ym\u00DA\u00DA\u00DEJ\u00B7\u00CA\u00ED\u00EBH\u00EB\u00A4\u00EBn\u00AC\u00F7Y\u00BF\u00AFJ\u00BDjA\u00D5\u00D0\u0086\u00F0\r\u00AD\x1B\u00F1\u008D\u00E5\x1B_mJ\u00DEt\u00A1zj\u00F5\u008E\u00CD\u00B4\u00CD\u00CA\u00CD\x035a5\u00ED[\u00CC\u00B6\u00AC\u00DB\u00F2\u00A16\u00A3\u00F6z\u009D\x7F]\u00CBV\u00FD\u00AD\u00AB\u00B7\u00BE\u00D9&\u00DA\u00D6\u00BF\u00DDw{\u00F3\x0E\u0083\x1D\x15;\u00DE\u00EF\u0094\u00EC\u00BC\u00B5+xWk\u00BDE}\u00F5n\u00D2\u00EE\u0082\u00DD\u008F\x1Ab\x1B\u00BA\u00BF\u00E6~\u00DD\u00B8GwO\u00C5\u009E\u008F{\u00A5{\x07\u00F6E\u00EF\u00EBjtol\u00DC\u00AF\u00BF\u00BF\u00B2\tmR6\u008D\x1EH:p\u00E5\u009B\u0080o\u00DA\u009B\u00ED\u009Aw\u00B5pZ*\x0E\u00C2A\u00E5\u00C1'\u00DF\u00A6|{\u00E3P\u00E8\u00A1\u00CE\u00C3\u00DC\u00C3\u00CD\u00DF\u0099\x7F\u00B7\u00F5\b\u00EBHy+\u00D2:\u00BFu\u00AC-\u00A3m\u00A0=\u00A1\u00BD\u00EF\u00E8\u008C\u00A3\u009D\x1D^\x1DG\u00BE\u00B7\u00FF~\u00EF1\u00E3cu\u00C75\u008FW\u009E\u00A0\u009D(=\u00F1\u00F9\u00E4\u0082\u0093\u00E3\u00A7d\u00A7\u009E\u009DN?=\u00D4\u0099\u00DCy\u00F7L\u00FC\u0099k]Q]\u00BDgC\u00CF\u009E?\x17t\u00EEL\u00B7_\u00F7\u00C9\u00F3\u00DE\u00E7\u008F]\u00F0\u00BCp\u00F4\"\u00F7b\u00DB%\u00B7K\u00AD=\u00AE=G~p\u00FD\u00E1H\u00AF[o\u00EBe\u00F7\u00CB\u00EDW<\u00AEt\u00F4M\u00EB;\u00D1\u00EF\u00D3\x7F\u00FAj\u00C0\u00D5s\u00D7\u00F8\u00D7.]\u009Fy\u00BD\u00EF\u00C6\u00EC\x1B\u00B7n&\u00DD\x1C\u00B8%\u00BA\u00F5\u00F8v\u00F6\u00ED\x17w\n\u00EEL\u00DC]z\u008Fx\u00AF\u00FC\u00BE\u00DA\u00FD\u00EA\x07\u00FA\x0F\u00EA\x7F\u00B4\u00FE\u00B1e\u00C0m\u00E0\u00F8`\u00C0`\u00CF\u00C3Y\x0F\u00EF\x0E\t\u0087\u009E\u00FE\u0094\u00FF\u00D3\u0087\u00E1\u00D2G\u00CCG\u00D5#F#\u008D\u008F\u009D\x1F\x1F\x1B\r\x1A\u00BD\u00F2d\u00CE\u0093\u00E1\u00A7\u00B2\u00A7\x13\u00CF\u00CA~V\u00FFy\u00EBs\u00AB\u00E7\u00DF\u00FD\u00E2\u00FBK\u00CFX\u00FC\u00D8\u00F0\x0B\u00F9\u008B\u00CF\u00BF\u00AEy\u00A9\u00F3r\u00EF\u00AB\u00A9\u00AF:\u00C7#\u00C7\x1F\u00BC\u00CEy=\u00F1\u00A6\u00FC\u00AD\u00CE\u00DB}\u00EF\u00B8\u00EF\u00BA\u00DF\u00C7\u00BD\x1F\u0099(\u00FC@\u00FEP\u00F3\u00D1\u00FAc\u00C7\u00A7\u00D0O\u00F7>\u00E7|\u00FE\u00FC/\u00F7\u0084\u00F3\u00FB%\u00D2\u009F3\x00\x00\x00\x04gAMA\x00\x00\u00B1\u008E|\u00FBQ\u0093\x00\x00\x00 cHRM\x00\x00z%\x00\x00\u0080\u0083\x00\x00\u00F9\u00FF\x00\x00\u0080\u00E9\x00\x00u0\x00\x00\u00EA`\x00\x00:\u0098\x00\x00\x17o\u0092_\u00C5F\x00\x00\x01\u0091IDATx\u00DA\u00A4\u0093M/\x03A\x18\u00C7\x7F\u00D3\u00A0\u0091\u00A0\u00D4K\x10\u0089\u0084\x1E$\u00DE\x0E\u009CH\u00A8\u009B\u00C4\u00C17\x10\u008E|\x03\u0089\u0093\x0F\u00C1\u00D1W\u00E0\u00C6m]\x1C\u00B8l\u00E2$^R%H\x13J\u00B7\u00E9\u00D6\u00CE\u00CE\u008E\u00C3n\u0099Z\x07I'y2\u0093\u0099\u00F9\u00FF\u00FE\u00CF3/BkM#-A\u0083\u00AD\u00A96\x10B\u00B0y\u00AC;\u0081l*\u00C9j*\t\u00DBsb\u00C3\u009C\x1B\u00EF!{]$\u00B7\u00BB \u0096j\u0099\u008B\u00DA`\u00EB\u0084\u00F5\u0095\f\x07\u00D3}0\u00D4\x0Eg\u008Fp\u00FE\u008C5\u00DCA6\u0093\x02\u00E9\u00C3\u00CD;\u0094\x15\u0085\u00A72\u00AD;\u00F3t\u00FC.aqe4\x14\u00FB\x01\u008C\u00A5a\u00AA\u0097l\u00A0\u00E1\u00AA\b\u00AE\u0082\u00C94\u00A4\x13(\x02r\u00B1\x12\u00D6&X\u00BF~\u0083\u00C1v\u00F0$Xy\u0098\u00E9\u0087D\x00\u00AE\x07U\t\u00CE'\x04\x1A\x1CIO\f\u00F0Z\r\u00C3.@W\x12f\u00FB\u00A1E@E\u0081\n\u00A2P!\u00A0Y`\u00C5\x00\x00\u0099.\x18I\u0081\u00E7C\u00C5\u0083\u00AA\x17\n\u00FD(j\u00A0\u0092\u00A4;v\u008D\u00AF.d:C\x07_\u00FD\b\u0095\u0091\u0081\u00AF\u00A3u\u00CDS\f\u00F0\u00E6\u0082\u00D6\u0086\u00A3\x02\x15n\u00AEs\u00FF\fh\x01\u00EEc\u0080tk$P\u0086\u00C0t\u008Fz\u00C7H\u00BF\x0E\u00E0\u00CAzw\u00B3nCLI\x02\u00FCq\u0088\u00AE\x1Fm6\\]\x1F\u00EEK\u0090/\u00C3\u008B\u008B\u00EDH,\u00E0\x14\u00B0c\u0080\u0081\u00B6Pt\u00F7\x01\u00B7E\u00C8;\u00BC?\u0094\u00B1\u0080#\u00C0\u00DA_\x1693\u00F5\u00BD\u00E8\x05\x7F\x03.\x0Bp\u00F1\u008C]\u0091\x1C\x01\u0087\u00FB\u00CB\u00C2\u00FE\u00CFg\x12\u008D~\u00E7\u00AF\x01\x00>J\u00F1\n\u00BB\x15\u00C9O\x00\x00\x00\x00IEND\u00AEB`\u0082",
        "pbg_icon.png": "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x10\b\x06\x00\x00\x00\x1F\u00F3\u00FFa\x00\x00\x00\tpHYs\x00\x00\x00\x01\x00\x00\x00\x01\x018\"\u00F4@\x00\x00\x00$zTXtCreator\x00\x00x\u009CsL\u00C9OJUpL+I-RpMKKM.)\x06\x00Az\x06\u00CE\u00E7\u00CDsf\x00\x00\x02\x0EIDAT8\u008D\u0095\u0092\u00B1K[Q\x14\u00C6\x7F\u00F7\u00DE\u0087\u00E6\u0099\u00C0{\x06#\u008D\x04Kx\u008B[BH\u009B\n%]\u008A\u00D4]\u00D7\u00FE\x03\"8\x14\x02\x05G\u008Bt\u00D3@\u00B6\u00CCBA\u00BAu\nq+dIx\u0094\f\x19\x14B\u00F2\u0096\u00A2K\u00CB\u00A3Q\u0093\u00DC\x0E\u00E9{\u00FA*H\u00FB\u0083\u00C3\x1D.\u00E7;\x1F\u00DF9Bk\u00AD\u0098\u00F1\u00F4\u00F8\u00F8\u00F8\u00BC\u00D7\u00EB\x11\u00A0\u00B5\x0E\u00DF\u00F1x\u00CC\u00F2\u00F22\u00A9T\u008A\u00BD\u00BD=\x07\u00E8\x03\x18\u00DC\u00E3\u00E2\u00E2\u0082\u00FD\u00FD}\u00B4\u00D6a\u00B3\x10\x02!\x04WWWH)\u00E9v\u00BBT\u00AB\u00D5\u00F3\u00DD\u00DD]\x07\u00E8\u008B\u00E7\u00AF\x0F\u00B5\u0094\x11\u009D\x07h=\u00E5\u00F0\u00FD3\u00CA\u00E52\u00C3\u00E1\u0090v\u00BB\u008D\u00E7y\u00EC\u00EC\u00EC8\u00C6\u00ED\u00F5\u008FG\u009B\x03|\u00DF\x07 \u0093\u00C9\x10\u008F\u00C7i\u00B5Z\u00D4j\u00B5s\u00E3\u00E6\u00FA\u00E7?\t\u0098\u00A6\u00C9\u00C1\u00C1\x01\u009E\u00E7\u00E18\x0E\u00EB\u00EB\u00EB\u00B8\u00AE\u008B1\u00F2\u00BFs{\u00F3\u00B8\u00882b\u00A4\u00D3i677\u00F1}\x1F\u00D34YZZ\"\x16\u008Ba4\u00BF||\u00E9\u00FB~\f\u00A0^\u00AF7\u00B6\u00B7\u00B7#\u00CDB\b\x16\x16\x16\u00B0m\u009B\u0095\u0095\x15\u0084\x10H)\x11B0??\u008Fa\u009A\u00A6kY\u0096\x01\u0090L&I\u00A7\u00D3\x00\f\x06\x03VWW\u00E9\u00F7\u00FBL&\x13F\u00A3\x11RJ\x00\u00D6\u00D6\u00D6B!#\u0095J\u00FD\n\u00A6%\x12\t,\u00CB\x02\u00C0\u00B6m\x00r\u00B9\\\u00E8$\u00A8\u00C0\u0081\u00942z\x07sss(5\u00BB+\u00D7u\u00C9\u00E7\u00F3t:\x1D\u00E0\u00EE\u00A8\x00J\u00A5R(\x16\x110\f#\u00B4Y(\x14\x00(\x16\u008B\x0F\x1C\u00DCw\"#i+\x15\u00D6\u00C9\u00A7\u00CF(\u00A5proQJqvvF\u00B3\u00D9\u00A4\u00D1h\u00CC\x1A\u00FF\f\u008A8\u0098L&\u00E1\u00C7`\u00E8QxU\u00C1\u00B2\u009F \u00A5dcc#\u009C\x1C0\u009DN\u00A3\x02\u00E3\u00F18\u00CC \u00B9\u00B8\u00C8\u00B7\u00AF\u00EFx\u00F1\u00E6\x03J)NOO\u00C3\x1C\u00B6\u00B6\u00B6\u00EEr\u00D1Z\u00AB\u00A0\u008E\u008E\u008E\u00F4\u00FFP\u00A9Tt\u00C4A\u00A7\u00D3!\u009B\u00CDryy\u00C9\u00DF\u00DC\u00DF\x02\u00CC\u00D6\\,\x16\u00F9\r{\x0B\u00E3\u0098\x0F.\u00D5\u00D7\x00\x00\x00\x00IEND\u00AEB`\u0082",
        "pbk_icon.png": "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x10\b\x06\x00\x00\x00\x1F\u00F3\u00FFa\x00\x00\x00\tpHYs\x00\x00\x00\x01\x00\x00\x00\x01\x018\"\u00F4@\x00\x00\x00$zTXtCreator\x00\x00x\u009CsL\u00C9OJUpL+I-RpMKKM.)\x06\x00Az\x06\u00CE\u00E7\u00CDsf\x00\x00\x02bIDAT8\u008D\u008D\u0093\u00CFKTQ\x14\u0080\u00BF{\u00EFsf\u009E3\u00F2\x06\u00F3\u00A9\u00EFe\u009A\fEVX\x0B\u00FB1 \u00AE\u00DA(\x11\x04\x0E\x04A\u00D0Z\x04wB\u00E0&\x12$(\u00FC\u0081.\x02\u00FF\u0082\u00A0\"*\u008C\u00AC\u00DC\u00BAPq\u00E1\u00C2\u00C5L\b\u00CE\u00A6f\u00A0\u00B4\u00A7\u00E3\u00F8\u00E6\u00DD\x16:\u0083\u0083a}p\u00B8ws\u00BE{\u00CE\u00BD\u00F7\b\u00AD\u00B5\u00E2\u0080\u00B6\u00C9\u00C9\u00C9\u00F4\u00FA\u00FA:e\u00B4\u00D6\u0095\u00D5\u00F7}\x1A\x1B\x1B\u00B1m\u009B\u00A1\u00A1\u00A1\x04\u00B0\x01`p\u0084L&\u00C3\u00C8\u00C8\bZ\u00EBJ\u00B2\x10\x02!\x04\u00F9|\x1E)%kkkLMM\u00A5\x07\x07\x07\x13\u00C0\u0086\u00B8~kLKY\u00E59\u0086\u00D6\x01c\u008F\u00AE\u00D1\u00D3\u00D3\u00C3\u00E6\u00E6&\u00CB\u00CB\u00CBd\u00B3Y\x06\x06\x06\x12\u00C6\u00FE\u00DE\u00D6\u0089\u00C9e<\u00CF\x03\u00A0\u00A5\u00A5\u0085h4\u00CA\u00E2\u00E2\"333i\u00A3\u00B8\u00B7\u00FD_\x02\u00D34\x19\x1D\x1D%\u009B\u00CD\u0092H$H&\u0093\u00AC\u00AE\u00AEb\x14\u00BC\u00EF\u00EC\x17O\u0096(#\u0082\u00E38\u00F4\u00F6\u00F6\u00E2y\x1E\u00A6i\u00D2\u00D0\u00D0@$\x12\u00C1\u00F8\u00F2\u00E1i\u00B7\u00E7y\x11\u0080\u00D9\u00D9\u00D9\u00F9T*U\u0095,\u0084\u00A0\u00B6\u00B6\u0096x<\u008E\u00EB\u00BA\b!\u0090R\"\u0084 \x1C\x0E#M\u00D3\\u]w\u00C9u\u00DD\u00A5\u00FA\u00FAz\x1C\u00C7\u00E1\u00F5\u009B\u00F7\u00A43\u00DFp]\x17\u00C7q*\u00A7\x01\u00BC|5\u00C7\u00D5\u009B\u00F7\u0091R\x1E\u0084m\u00DB\u00BB\u0096em[\u0096\u00B5\x1D\u008B\u00C5\u00B0,\u008Bf\u00D7\u00E5G\u00EE'\u00F3\u009F\x17\u00B0,\u008Bh4\u00CA\u00CE\u00CE.o\u00DF-\u00F0lz\x0E\f\u00BB\"\u00A8z\u00BFP(\u0084R\u008A}\u00BFD],\u0086\x1Fh\u00E6>~\u00E2b\u00C7\x05~m\u00ED1\u00FE\u00E2+F\u00F8\x14\u00B2\u00A6Ti\u00A3J`\x18\x06RJ\n\u0085\x02\u0086R\u0098\u00A6\u00C9\u00F6o\u008F\u00D6\u00D63\u00A4\x1ENc\u0084m\x14\x1A]\u00F2\u00FF^\u0081R\n\u00A5\x14\u00BB\u00BB\x05\u0084\x10\u00D4\u00D4\x18\u00DC\u00EE\u00EB#b\u009A\u00B4\u009Dm\u00A3\u0098\u00CE\x13hM\u00E9P\x00 \u008F\nJ\u00A5\u0083\u00D2\u008A\u00C5\"\x00\u00DD\u00C9\x1B8\u00CDM()\x19\x7F\u00D2\u00CF\u00E5\u008E\u00D3XV\x1D\u00A1P\x04!\x04A\x10T\x0B|\u00DFG)\u00C5\u00F9s\t\u00EE\u00A5\u00EE\u00D2\u00D9y\t)%J)j\u00CD\x10\u00CF\x1F\u00DF\u00E1A\u00FF\x15\u00DC&\x138\x1C6\u00AD\u00B5*\u00C7\u00C4\u00C4\u0084\u00FE\x17A\x10T\u00F6\u00C3\u00C3\u00C3\u00BA\u00EA\x0EVVVhoo'\u0097\u00CB\x1D\u00FB\u008D\u00E5\u00E9,\x13\u008F\u00C7\u00E9\u00EA\u00EA\u00E2\x0F\u00B21\x00CNG\u00BF\u0086\x00\x00\x00\x00IEND\u00AEB`\u0082",
    }
    
    var myFile = new File(resourceFolder+"/"+filename);
    if (!File(myFile).exists)
    {
        if (isAfterEffects () && !(isSecurityPrefSet())) 
        {
            alert ("This script requires access to write files.\n" +
            "Go to the \"General\" panel of the application preferences and make sure " + 
             "\"Allow Scripts to Write Files and Access Network\" is checked.");	
            app.executeCommand(2359);
            if (!isSecurityPrefSet()) return null; 
        }
        myFile.encoding = "BINARY";
        myFile.open( "w" );
        myFile.write( binaryStrings[filename] );
        myFile.close();
    }
    return myFile;
}

//This script UI are made from sample script "SnpCreateTreeView.jsx"

////////////////////////////////////////////////////////////////////////////
// ADOBE SYSTEMS INCORPORATED
// Copyright 2007 Adobe Systems Incorporated
// All Rights Reserved
//
// NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the
// terms of the Adobe license agreement accompanying it.  If you have received this file from a
// source other than Adobe, then your use, modification, or distribution of it requires the prior
// written permission of Adobe.
/////////////////////////////////////////////////////////////////////////////

/** 
 @fileoverview Shows how to use a tree-view list element, and how to capture events with 
 	either callback functions or script-registered event listeners.
 @class Shows how to use a tree-view list element, and how to capture events with 
 	either callback functions or script-registered event listeners.
 
  <h4>Usage</h4>
   
   
   <ol>
   <li>Run the snippet in the ExtendScript Toolkit (see Readme.txt).
    <li>Expand and collapse the list elements
    <li>Inspect the JavaScript Console to see the captured events from the TreeView elements.
  </ol>

  <h4>Description</h4>
  
  <p>Creates two TreeView hierarchical list components. One is static, with a fixed set of item
  nodes that you can expand and collapse. The other is dynamic; item nodes are added and removed as 
  as needed to show a view of the filesystem.  
  
  <p>The list items in the TreeView use custom images to display folders and files.  When adding items to the 
  TreeView list, the type 'item' is used for leaf elements and 'node' for container elements.
  
  <p>The dynamic TreeView captures events in two different ways. It uses callback functions to capture the
  node expand and collapse events and selection changes, and also registers an event listener to 
  capture double-click events.<br />
  
    @constructor Constructor 
 */
function SnpCreateTreeView(thisObj) 
{
    //CREATE IMAGES FROM BINARY STRING
    
    var resourceFolder = Folder.userData.fsName + "/Aescripts/Crossphere";
    if (!Folder(resourceFolder).exists) Folder(resourceFolder).create();

	/**
	 The context in which this snippet can run.
	 @type String
	*/
	this.requiredContext = "\tRequires the target application to support ScriptUI\n";	

	/**
	  The file-system location of the PNG resource file used to represent folders
	  @type File
	*/
	this.folderIcon = createResourceFile ("Folder_16x16.png", resourceFolder);

	/**
	  The file-system location of the PNG resource file used to represent files
	  @type File
	*/
    this.pbgIcon = createResourceFile ("pbg_icon.png", resourceFolder);
    this.pbkIcon = createResourceFile ("pbk_icon.png", resourceFolder);
    

	/**
	  The root folder that will be used for the dynamic tree
	  @type String
	*/
    this.rootFolder;
    if(isAfterEffects () && app.settings.haveSetting("cs_PBA_Launcher","rootFolder"))
    {
        var stored = app.settings.getSetting("cs_PBA_Launcher","rootFolder");
        var check_folder = new Folder(stored);
        if(check_folder.exists)
        {
            this.rootFolder = check_folder;
        }
        else
        {
            this.rootFolder = Folder.myDocuments;
        }
    }
    else
    {
        this.rootFolder = Folder.myDocuments;
    }
}

/**
    @brief add child for node of tree view
    @param[in]      that    instance of tree view.
    @param[inout]   item    a tree node. added some child items
    @param[in]      folder  instance of folder correspond to the "item" param
    @param[in]      depth   from root folder. if negative, stop adding more deep parts.
 */
function AddChildItem(that, item, folder, current_depth)
{
    var folder_items = folder.getFiles();
    var num_items = folder_items.length;
    for(var i = 0 ; i < num_items ; i++)
    {
        var folder_item = folder_items[i];
        if(folder_item instanceof File)
        {
            var temp = folder_item.displayName.split(".");
            var len = temp.length;
            var extention = temp[len -1];
            if( extention.toLowerCase() == "pbk"|| extention.toLowerCase() == "pbg")
            {
                var child_item = item.add("item", folder_item.displayName);
                if(extention.toLowerCase() == "pbk")
                {
                    child_item.image = that.pbkIcon;
                }
                else
                {
                    child_item.image = that.pbgIcon;
                }
            }
        }
        else if(folder_item instanceof Folder)
        {
            var child_item = item.add("node", folder_item.displayName);
            child_item.image = that.folderIcon;
            if(current_depth >= 0 && current_depth+1 < g_Max_folder_depth)
            {
                AddChildItem(that, child_item, folder_item, current_depth + 1);
            }
        }
    }
}


/**
 Functional part of this snippet. Creates the ScriptUI window and its components ,
 and defines the behavior.
 @return True if the snippet ran as expected, false otherwise
 @type boolean
*/
SnpCreateTreeView.prototype.run = function() 
{
    
    if (thisObj instanceof Panel) {
		var win = thisObj;
		} else {
			var win = new Window("palette", "PBA Launcher v"+scriptVersion, undefined, {resizeable: true});
        }

	// Create the panel for the dynamic TreeView
	var dPanel = win.add("panel", undefined, "Pixel Bender Files");
    dPanel.alignment = ["fill","fill"];
    dPanel.alignChildren = ["fill","fill"];
 
	// Create the TreeView list
	var dTv = dPanel.add("treeview", undefined);
    dTv.alignment = ["fill","fill"];
    dTv.alignChildren = ["fill","fill"];
	dTv.preferredSize = [300, 300];
	// Create the root node item
	var rootNode = dTv.add("node", this.rootFolder.name);
	// Associate it with an icon image
    rootNode.image = this.folderIcon;
    
    if(isCreativeClouds())
    {
        //make static tree view for first time
        AddChildItem(this, rootNode, this.rootFolder,0);
    }

	// Keep a reference to this object
	var that = this;

	// Define an event handler for when a node is expanded
    dTv.onExpand  = function (item)
	{ 
        if(isCreativeClouds())
        {
            //on AE CC, dynamic tree view does not work currently.
            return ;
        }
    
		var nextItem = item;
		var path = "";
		var goUp = true;

		while(goUp)
		{
            if(nextItem == rootNode)
            {
                break;
            }
            if(File.fs=="Windows")
            {
                path = "\\" + nextItem.text + path;
            }
            else
            {
			path = "/" + nextItem.text + path;
            }
            nextItem = nextItem.parent;
            if(nextItem instanceof TreeView)
            {
                goUp = false;
            }
        }

        // Remove all the children of this item
        item.removeAll();

        var ref = new Folder(that.rootFolder.fsName + path);
        var i_count = 0;
        if(ref instanceof Folder)
        {
            AddChildItem(that, item, ref, -1);
        }
	}

    var bGroup = win.add("Group");
    bGroup.alignment = ["fill","bottom"];
    bGroup.alignChildren = ["fill","bottom"];
    
    var helpBtn = bGroup.add("button",[0,0,40,40],"?");
    helpBtn.alignment = ["left","middle"];
    helpBtn.onClick = function()
    {
        alert("PBA Launcher v"+scriptVersion+"\n1. Choose the folder where your Pixel Bender filters reside by pressing the \"Folder\" button.\n\n2. Once you've selected the folder you can choose the Pixel Bender filter from the list and click the \"Apply\" button to apply it with Pixel Bender Accelerator to your layer.\n\nOf course, the Pixel Bender Accelerator plugin needs to be installed first :)");
        }
    var aFolder = bGroup.add("button",[0,0,100,40],"folder");
    aFolder.onClick = function()
    {
        var temp_Folder = Folder.selectDialog("Choose Pixel Bender Folder");
        if(temp_Folder == null || !temp_Folder.exists)
        {
            return ;
        }
        that.rootFolder = temp_Folder;

        if(isAfterEffects ())
        {
            app.settings.saveSetting("cs_PBA_Launcher","rootFolder",temp_Folder.fsName);
        }
        
        rootNode.text = that.rootFolder.name;
        rootNode.expanded = false;
        
        if(isCreativeClouds())
        {
            //construct static tree view
            rootNode.removeAll();
            AddChildItem(that, rootNode, that.rootFolder, 0);
        }
    }


    var aButton = bGroup.add("button",[0,0,100,40],"apply");
    aButton.onClick = function()
    {
        var sel = dTv.selection;
        if(sel == null)
        {
            alert("Choose .pbk or .pbg","PBA_Launcher");
            return;
        }
        
        var ar = new Array();
        var par = sel;
        var i = 0;
        while(par != null && par != dTv)
        {
           ar[i] = par;
           par = par.parent;
           i++;
        }

        var fullpath = that.rootFolder.fullName;
        for(var j = 1 ; j < i; j++)//j = 1 is "/"
        {
            fullpath += "/" + ar[i-j-1].text;
        } 
        var target_file = File(fullpath);
        if(target_file instanceof File)
        {
            apply_PBA_to_selected_layer(target_file.fsName);
        }
        else
        {
            alert("Choose .pbk or .pbg","PBA_Launcher");
        }
    }

    	win.layout.layout(true);
		win.layout.resize();
		win.onResizing = win.onResize = function () {this.layout.resize();}
	// Display the window
    if (!(thisObj instanceof Panel)) win.show();
	
	return true;
}


/**
 "main program": construct an anonymous instance and run it
  as long as we are not unit-testing this snippet.
*/
if(typeof(SnpCreateTreeView_unitTest ) == "undefined") {
	new SnpCreateTreeView(thisObj).run();
}

}

cs_PBA_Launcher (this);